local tvRP = Proxy.getInterface("vRP")
local vRPserver = Tunnel.getInterface(GetCurrentResourceName(), GetCurrentResourceName())

local showroomPos = vec3(-29.664981842041,-1104.4794921875,26.42234992981)
local showroomBlip = nil

local canOpen, isOpened = false, false
local vehicleSpawned, testDrive, vehicleColor = false, 0, {r = 255, g = 255, b = 255}
local newVehicle
local vehCamera = nil
local menuActive = false

local function changeCamera()
    print("Începere changeCamera")
    DoScreenFadeOut(1000)
    Wait(1000)

    local targetPos = vec3(-2015.9108886719,-360.81817626953,49.106346130371)
    print("Teleportare la: " .. json.encode(targetPos))
    
    tvRP.teleport({targetPos.x, targetPos.y, targetPos.z})    
    Wait(500)

    FreezeEntityPosition(PlayerPedId(), true)

    local pos = {-2015.9108886719,-360.81817626953,48.106346130371}
    local g = Citizen.InvokeNative(0xC906A7DAB05C8D2B,pos[1],pos[2],pos[3],Citizen.PointerValueFloat(),0)
    print("Ground Z: " .. tostring(g))

    tvRP.teleport({pos[1], pos[2], g})
    SetEntityHeading(PlayerPedId(), 161.3)
    SetEntityVisible(PlayerPedId(), false)
    
    if not DoesCamExist(vehCamera) then
        print("Creare cameră nouă")
        vehCamera = CreateCam('DEFAULT_SCRIPTED_CAMERA', true)
    end
    
    SetCamActive(vehCamera, true)
    SetCamRot(vehCamera, vec3(-10.0, 0.0, 161.3), true)
    SetCamFov(vehCamera, 50.0)
    SetCamCoord(vehCamera, vec3(-2017.9108886719,-344.81817626953,49.106346130371))
    PointCamAtCoord(vehCamera, vec3(-2017.9108886719,-344.81817626953,49.106346130371))
    RenderScriptCams(true, false, 2500.0, true, true)

    DoScreenFadeIn(1000)
    TriggerEvent("vRP:updateInterfaceState", false)
    DisplayRadar(false)
    Wait(1000)
    print("Finalizare changeCamera")
end

local function destroyDealership()
    DeleteEntity(newVehicle)
    DoScreenFadeOut(500)
    tvRP.teleport({showroomPos.x, showroomPos.y, showroomPos.z})

    FreezeEntityPosition(PlayerPedId(), false)
    SetEntityVisible(PlayerPedId(), true)

    Wait(1000)

    DoScreenFadeIn(1000)
    RenderScriptCams(false, false, 1, true, true)
    DestroyAllCams(true)
    TriggerEvent("vRP:updateInterfaceState", true)
    DisplayRadar(true)
end

RegisterNUICallback("setFocus", function(data, cb) 
    if not data.state and not testDrive then
        destroyDealership()
    end
    SetNuiFocus(data.state, data.state) 
    isOpened = data.state
end)

RegisterNUICallback("exitUi", function(data, cb) 
    --if not data.state and not testDrive then
        destroyDealership()
    --end
    SetNuiFocus(data.state, data.state) 
    isOpened = data.state
end)

RegisterNUICallback("spawnVehicle", function(data, cb)
    if not data.model then
        if DoesEntityExist(newVehicle) then
            DeleteEntity(newVehicle)
        end
    end

    local model = data.model
    local hash = GetHashKey(model)

    RequestModel(hash) 
    while not HasModelLoaded(hash) do
        Wait(1)
    end

    if vehicleSpawned then
        DeleteEntity(newVehicle)
        vehicleSpawned = false
    end

    newVehicle = CreateVehicle(hash, -2020.9108886719,-353.81817626953,48.106346130371, 261.46661, false, false)
    SetVehicleCustomPrimaryColour(newVehicle, 255, 255, 255)
    SetVehicleCustomSecondaryColour(newVehicle, 255, 255, 255)
    NetworkFadeInEntity(newVehicle, 1)
    vehicleSpawned = true
end)

RegisterNUICallback("setVehicleColor", function(data, cb)
    SetVehicleCustomPrimaryColour(newVehicle, data.r, data.g, data.b)
    vehicleColor = {r = data.r, g =data.g, b =data.b}
end)

local vehicle = false
RegisterNUICallback("testDrive", function(data, cb)
    vRPserver.canTestDrive({}, function(can)
        if can then
            testDrive = true
            tvRP.notify({"Ai 1 minute la dispozitie sa testezi masina"})
            local model = data.model
            Citizen.Wait(500)

            if not vehicle or not DoesEntityExist(vehicle) then
                local i, mhash = 0, GetHashKey(model)

                while not HasModelLoaded(mhash) and i < 1000 do
                    if i % 50 == 0 then
                        RequestModel(mhash)
                    end
                    Citizen.Wait(1)
                    i = i+1
                end

                vehicle = CreateVehicle(mhash, -63.828220367432,-1132.0690917969,25.831851959229, 180.0, false, false)
                SetVehicleMaxSpeed(vehicle, 0.0)
                NetworkFadeInEntity(vehicle, 0)
                SetVehicleOnGroundProperly(vehicle)
                SetEntityInvincible(vehicle, true)
                FreezeEntityPosition(vehicle, true)
                SetVehicleDirtLevel(vehicle, 0.0)
                SetVehicleCustomPrimaryColour(vehicle, vehicleColor.r, vehicleColor.g, vehicleColor.b)
                SetVehicleCustomSecondaryColour(vehicle, 255, 255, 255)
                SetVehicleNumberPlateText(vehicle, "AUTOTEST")

            end


            if DoesEntityExist(vehicle) then
                testDrive = true

                DoScreenFadeOut(700)
                Citizen.Wait(800)

                SetEntityVisible(PlayerPedId(), true)
                ClearFocus()
                RenderScriptCams(false, false, 0, true, false)
                DestroyAllCams(true)
                menuActive = false

                SetPedIntoVehicle(PlayerPedId(), vehicle, -1)
                Citizen.Wait(100)
                FreezeEntityPosition(vehicle, false)
                SetEntityCoords(vehicle, -63.828220367432,-1132.0690917969,25.831851959229)
                SetEntityHeading(vehicle, 90.0)
                TriggerServerEvent("vRP:setWorld", "user_id")

                Citizen.Wait(1000)
                DoScreenFadeIn(1000)

                local untilTime = GetGameTimer() + 60000

                SendNUIMessage({
                    act = "testDrive",
                    state = false
                })

                while GetGameTimer() < untilTime do
                    Citizen.Wait(1)

                    DisableControlAction(0, 75)

                    if IsDisabledControlJustPressed(0, 75) then
                        break
                    end

                end

                DoScreenFadeOut(700, true)
                Citizen.Wait(800)
                changeCamera()
                SendNUIMessage({
                    act = "testDrive",
                    state = true
                })

                TriggerServerEvent("vRP:setWorld", 0)

                DeleteEntity(vehicle)
                vehicle = nil
                
                Citizen.Wait(1000)
                DoScreenFadeIn(1000, true)

                testDrive = false
            end
        else
            SendNUIMessage({
                act = "closeShowroom"
            })
            tvRP.notify({"Nu ai destui bani"})
        end
    end)
end)

RegisterNUICallback("buyVehicle", function(data, cb)
    vRPserver.buyVehicle({data.model,data.price,data.name,data.method})
    destroyDealership()
end)

Citizen.CreateThread(function()
    ::update::

    if #(showroomPos - GetEntityCoords(PlayerPedId())) <= 2.5 then
        canOpen = true
    else
        canOpen = false
    end

    Wait(1000)
    goto update
end)

RegisterNetEvent("showroom:receiveVipLevel")
AddEventHandler("showroom:receiveVipLevel", function(vipLevel)
    if vipLevel and tonumber(vipLevel) > 0 then
        changeCamera()
        SetNuiFocus(true, true)
        SendNUIMessage({
            act = "openShowroom",
            vipLevel = tonumber(vipLevel)
        })
        isOpened = true
    else
        TriggerEvent("chatMessage", "SYSTEM", {255, 0, 0}, "Nu ai acces la showroom. Ai nevoie de VIP.")
    end
end)

RegisterCommand("openshowroom", function()
    if not canOpen then
        return
    end
    
    if isOpened then
        return
    end
    
    local playerServerId = GetPlayerServerId(PlayerId())
    TriggerServerEvent("showroom:requestVipLevel")
end)

RegisterNetEvent("Unlimited-showroom")
AddEventHandler("Unlimited-showroom", function()
    if not canOpen then
        return
    end
    
    if isOpened then
        return
    end
    
    local playerServerId = GetPlayerServerId(PlayerId())
    TriggerServerEvent("showroom:requestVipLevel")
end)

Citizen.CreateThread(function()
	local Unlimitedshowroom = vector3(-31.018503189087,-1106.8081054688,26.422357559204)
	tvRP.spawnNpc({"vRP:Unlimitedshowroom", {
		position = Unlimitedshowroom,
		rotation = 0,
        model = "a_m_y_smartcaspat_01",
		freeze = true,
		scenario = {
			name = "WORLD_HUMAN_CLIPBOARD_FACILITY"
		},
		minDist = 3.5,
		
		name = "Bogdan Vanzatorul",
        buttons = {
            {text = "Vreau sa-mi cumpar o masina", response = "post:client:Unlimited-showroom"},

        }},
	})

end)

-- Adaug NPC la coordonatele specificate
local npcCoords = vector3(-31.018503189087, -1106.8081054688, 26.422357559204 - 1.0) -- Ajustat pentru a fi mai jos
local npcModel = "a_m_m_business_01" -- Modelul NPC-ului, poți schimba la nevoie
local npcHeading = 0.0 -- Rotirea NPC-ului, ajustează după necesitate

Citizen.CreateThread(function()
    RequestModel(GetHashKey(npcModel))
    while not HasModelLoaded(GetHashKey(npcModel)) do
        Citizen.Wait(1)
    end
    local npc = CreatePed(4, GetHashKey(npcModel), npcCoords.x, npcCoords.y, npcCoords.z, npcHeading, false, true)
    FreezeEntityPosition(npc, true)
    SetEntityInvincible(npc, true)
    SetBlockingOfNonTemporaryEvents(npc, true)
end)

-- Afișează textul 'Apasa [E] pentru a deschide Showroom' când jucătorul este aproape de NPC și deschide showroom-ul când apasă tasta E
Citizen.CreateThread(function()
    while true do
        Citizen.Wait(0)
        local playerCoords = GetEntityCoords(PlayerPedId())
        local distance = #(playerCoords - npcCoords)
        if distance < 5.0 then -- Mărit de la 2.0 la 5.0
            DrawText3D(npcCoords.x, npcCoords.y, npcCoords.z + 1.0, "Apasa [E] pentru a deschide Showroom")
            if IsControlJustReleased(0, 38) then -- Tasta E
                OpenShowroom()
            end
        end
    end
end)

-- Funcție pentru deschiderea showroom-ului
function OpenShowroom()
    -- Aici poți adăuga codul pentru a deschide showroom-ul
    -- De exemplu, poți trimite un eveniment către server sau deschide un meniu
    TriggerEvent("Unlimited_showroom:open")
end

-- Funcție pentru afișarea textului 3D
function DrawText3D(x, y, z, text)
    local onScreen, _x, _y = World3dToScreen2d(x, y, z)
    local px, py, pz = table.unpack(GetGameplayCamCoords())
    local scale = 0.5 -- Mărit pentru text mai mare
    if onScreen then
        SetTextScale(scale, scale)
        SetTextFont(4)
        SetTextProportional(1)
        SetTextColour(162, 89, 255, 215) -- Culoare mov
        SetTextDropshadow(0, 0, 0, 0, 255)
        SetTextEdge(2, 0, 0, 0, 150)
        SetTextDropShadow()
        SetTextOutline()
        SetTextEntry("STRING")
        SetTextCentre(1)
        AddTextComponentString(text)
        DrawText(_x, _y)
    end
end

-- Funcție pentru crearea blip-ului
local function CreateShowroomBlip()
    if showroomBlip then RemoveBlip(showroomBlip) end
    
    showroomBlip = AddBlipForCoord(showroomPos.x, showroomPos.y, showroomPos.z)
    SetBlipSprite(showroomBlip, 326) -- Sprite pentru showroom
    SetBlipDisplay(showroomBlip, 4)
    SetBlipScale(showroomBlip, 0.8)
    SetBlipColour(showroomBlip, 1) -- Culoare roșie
    SetBlipAsShortRange(showroomBlip, true)
    BeginTextCommandSetBlipName("STRING")
    AddTextComponentString("Showroom VIP")
    EndTextCommandSetBlipName(showroomBlip)
end

-- Creăm blip-ul când se pornește resursa
Citizen.CreateThread(function()
    CreateShowroomBlip()
end)

RegisterKeyMapping('openshowroom','Deschide Showroom', 'keyboard', 'E')